/*+
|                                               |
|     Trigger: DTULTATU_JUSTIFICATIVA                |  
|     Tabela : JUSTIFICATIVA                         |
|                                               |
|     Criao:                                  |
|     09/07/2008 - Luiz Passos                  |
|                                               |
+*/

create or replace TRIGGER DTULTATU_JUSTIFICATIVA
BEFORE INSERT OR UPDATE OR DELETE
ON JUSTIFICATIVA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUJUSTIF := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDJUSTIFICATIVA,0) <> NVL(:NEW.CDJUSTIFICATIVA,0)) OR
           (NVL(:OLD.DSJUSTIFICATIVA,0) <> NVL(:NEW.DSJUSTIFICATIVA,0)) THEN
         :NEW.DTULTATUJUSTIF := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('JUSTIFICATIVA'  , '', 'CDJUSTIFICATIVA='||:OLD.CDJUSTIFICATIVA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE JUSTIFICATIVA MODIFY DTULTATUJUSTIF DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_SITUCAND','5.03.010'); END;
/

