CREATE OR REPLACE PROCEDURE ARQUIVO_ISS_RECIFE(
   P_NRLISTA     IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_CDEMPRESA   IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_NRSEQARQMAG IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_TIPOSERVICO IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_DTINICIAL   IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL     IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_CDINSCESTA  IN NOTAFISCAL.CDINSCESTA%TYPE)
AS
   V_CONTADOR        NUMBER;
   V_DTBAIXAPAG      DATE;
   V_DATAVAZIA       VARCHAR2(01);
   V_NRINSJUREMPR    VARCHAR2(20);
   V_CDFILIAL        VARCHAR2(04);
   V_NRLANCTONF      VARCHAR2(14);
   V_CODFABRICANTE   VARCHAR2(02);
   V_CNPJ_TOMADOR    VARCHAR2(21);
   V_CNPJ_PRESTADOR  VARCHAR2(21);
   V_TIPORECOLHE     VARCHAR2(01);
   V_RECIFE          VARCHAR2(01);
   V_DADOS_PREST     VARCHAR2(200);
   V_DADOS_ECF       VARCHAR2(200);
   V_DADOS_TOMAD     VARCHAR2(200);
BEGIN
   SELECT NVL(NRINSJUREMPR,'')
     INTO V_NRINSJUREMPR
     FROM EMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;
   V_CONTADOR := 0;
   V_NRLANCTONF := ' ';
   /*Servios Prestados - Notas de Sada*/
   IF P_TIPOSERVICO = 'P' THEN
      FOR C_PREST IN (SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRINSJURNF, NVL(PE.CDSITUCRT,'3') AS CDSITUCRT, NF.CDINSCMUNI, NF.DTEMISSAO, NF.CDSERIE,
                             NF.NRNOTAFISC, IP.VRBASECALCNF, IP.VRIMPOSTONF, IP.VRALIQNF, NF.IDORIGDESTNF,
                             IP.CDIMPOSTO, IM.CDIMPOSTONFE, NF.IDSTATUS, NF.CDFORNECED, NF.CDCLIENTE, NF.CDFILIRECE
                        FROM NOTAFISCAL NF, LISTA LS, PARAMEMPRESA PE, IMPOSTONF IP, IMPOSTO IM
                       WHERE LS.NRLISTA      = P_NRLISTA
                         AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                         AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                         AND NF.IDENTRSAIDOP = 'S'
                         AND IP.NRLANCTONF   = NF.NRLANCTONF
                         AND IP.CDFILIAL     = NF.CDFILIAL
                         AND IM.CDIMPOSTONFE  IN ('31','36')
                         AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                         AND PE.CDEMPRESA(+) = P_CDEMPRESA
                         AND IP.VRBASECALCNF  > 0
                         ORDER BY NF.CDFILIAL, NF.NRLANCTONF, IM.CDIMPOSTONFE DESC) LOOP
             IF (V_NRLANCTONF <> C_PREST.CDFILIAL||C_PREST.NRLANCTONF) THEN
               IF C_PREST.IDORIGDESTNF = 'C' THEN
                  SELECT NVL(NRINSJURCLIE,'')
                    INTO V_CNPJ_TOMADOR
                    FROM CLIENTE
                   WHERE CDCLIENTE = C_PREST.CDCLIENTE;
               END IF;
               IF C_PREST.IDORIGDESTNF = 'F' THEN
                  SELECT NVL(NRINSJURFORN,'')
                    INTO V_CNPJ_TOMADOR
                    FROM FORNECEDOR
                   WHERE CDFORNECED = C_PREST.CDFORNECED;
               END IF;
               IF C_PREST.IDORIGDESTNF = 'L' THEN
                  SELECT NVL(NRINSJURFILI,'')
                    INTO V_CNPJ_TOMADOR
                    FROM FILIAL
                   WHERE CDFILIAL = C_PREST.CDFILIRECE;
               END IF;
               IF C_PREST.IDSTATUS = 'C' THEN
                  V_TIPORECOLHE := 'C';
               ELSIF C_PREST.CDSITUCRT <> '3' THEN
                  V_TIPORECOLHE := 'Q';
               ELSIF C_PREST.CDIMPOSTONFE = '36' THEN
                  V_TIPORECOLHE := 'R';
               ELSE
                  V_TIPORECOLHE := 'A';
               END IF;
               SELECT '0001'||
                      RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(V_NRINSJUREMPR,'.',''),',',''),'-',''),'/',''),'0'),14,'0')||
                      LPAD(SUBSTR(C_PREST.CDINSCMUNI,1,8),8,0) ||       /*Inscrio Mercantil do Prestador*/
                      TO_CHAR(C_PREST.DTEMISSAO,'DD/MM/YYYY')  ||       /*Data de Emissao*/
                      RPAD(NVL(SUBSTR(C_PREST.CDSERIE,1,1),''),3,' ')|| /*Srie*/
                      '0000'|| /*Sub-Srie*/
                      LPAD(NVL(SUBSTR(C_PREST.NRNOTAFISC,LENGTH(C_PREST.NRNOTAFISC)-7,8),0),8,0)|| /*Nmero da Nota Final*/
                      REPLACE(LTRIM(TO_CHAR(ROUND(C_PREST.VRBASECALCNF,2), '000000000000.00')), '.', ',')|| /*Valor do servio*/
                      V_TIPORECOLHE|| /*Tipo de Recolhimento*/
                      DECODE(C_PREST.CDIMPOSTONFE,'36',REPLACE(LTRIM(TO_CHAR(ROUND(C_PREST.VRIMPOSTONF,2), '000000000000.00')), '.', ','),'000000000000,00')|| /*Valor Iss Retido*/
                      RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(V_CNPJ_TOMADOR,'.',''),',',''),'-',''),'/',''),'0'),14,'0')||
                      REPLACE(LTRIM(TO_CHAR(ROUND(C_PREST.VRALIQNF,2), '000000000000.00')), '.', ',')
                 INTO V_DADOS_PREST
                 FROM PARAMGERAL;
               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 (V_CONTADOR, V_DADOS_PREST, P_NRSEQARQMAG);
               V_CONTADOR := NVL(V_CONTADOR,0)+1;
               UPDATE NOTAFISCAL
                  SET IDEXPNFEISS = 'S'
                WHERE CDFILIAL       = C_PREST.CDFILIAL
                  AND NRLANCTONF     = C_PREST.NRLANCTONF;
               V_NRLANCTONF := C_PREST.CDFILIAL||C_PREST.NRLANCTONF;
            END IF;
      END LOOP;
      /*ECF*/
      FOR C_ECF IN (SELECT FI.CDINSCMUNI,
                           R.NRSERIEREDZ,
                           NVL(R.DSMODMARCAECF,'X') AS DSMODMARCAECF,
                           TO_CHAR(R.DTREDUCAOZ,'YYYYMM') AS DTREDUCAOZ,
                           IZ.VRALIQIMPRZ,
                           SUM(IZ.VRBCALCIMPRZ) AS VRBCALCIMPRZ
                      FROM IMPOSTOREDZ IZ, FILIAL FI, IMPOSTO I, REDUCAOZ R
                     WHERE IZ.DTREDUCAOZ BETWEEN P_DTINICIAL AND P_DTFINAL
                       AND IZ.CDFILIAL   = FI.CDFILIAL
                       AND IZ.CDFILIAL   = R.CDFILIAL
                       AND IZ.DTREDUCAOZ = R.DTREDUCAOZ
                       AND FI.CDEMPRESA  = P_CDEMPRESA
                       AND FI.CDINSCESTA = P_CDINSCESTA
                       AND IZ.CDIMPOSTO  = I.CDIMPOSTO
                       AND I.IDTPIMPOSFIS = 'I'
                       AND IZ.NRECFREDZ   = R.NRECFREDZ
                       AND IZ.CDCAIXA     = R.CDCAIXA
                     GROUP BY FI.CDINSCMUNI, R.NRSERIEREDZ, R.DSMODMARCAECF,TO_CHAR(R.DTREDUCAOZ,'YYYYMM'), IZ.VRALIQIMPRZ
                     ORDER BY TO_CHAR(R.DTREDUCAOZ,'YYYYMM')) LOOP
        IF SUBSTR(C_ECF.DSMODMARCAECF,1,7) = 'BEMATEC' THEN
           V_CODFABRICANTE := '01';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,6) = 'DARUMA' THEN
           V_CODFABRICANTE := '02';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'EPSON' THEN
           V_CODFABRICANTE := '03';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,3) = 'IBM' THEN
           V_CODFABRICANTE := '04';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,9) = 'INTERPRON' THEN
           V_CODFABRICANTE := '05';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,7) = 'ITAUTEC' THEN
           V_CODFABRICANTE := '06';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,3) = 'NCR' THEN
           V_CODFABRICANTE := '07';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,8) = 'SCHALTER' THEN
           V_CODFABRICANTE := '08';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'SONDA' THEN
           V_CODFABRICANTE := '09';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'SWEDA' THEN
           V_CODFABRICANTE := '10';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'URANO' THEN
           V_CODFABRICANTE := '11';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'YANCO' THEN
           V_CODFABRICANTE := '12';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'ZPM' THEN
           V_CODFABRICANTE := '13';
        ELSIF SUBSTR(C_ECF.DSMODMARCAECF,1,5) = 'ELGIN' THEN
           V_CODFABRICANTE := '14';
        ELSE V_CODFABRICANTE := '15';
        END IF;
        SELECT '0011'||
               RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(V_NRINSJUREMPR,'.',''),',',''),'-',''),'/',''),'0'),14,'0')||
               LPAD(SUBSTR(C_ECF.CDINSCMUNI,1,8),8,0)||     /*Inscrio Mercantil do Prestador*/
               RPAD(NVL(C_ECF.NRSERIEREDZ, ' '), 20, ' ')|| /*Srie*/
               V_CODFABRICANTE||                            /*Cod. fabricante*/
               C_ECF.DTREDUCAOZ||                           /*Data da reduo*/
               REPLACE(LTRIM(TO_CHAR(ROUND(C_ECF.VRALIQIMPRZ,2), '000000000000.00')), '.', ',')|| /*Valor do servio*/
               REPLACE(LTRIM(TO_CHAR(ROUND(C_ECF.VRBCALCIMPRZ,2), '000000000000.00')), '.', ',') /*Valor do servio*/
          INTO V_DADOS_ECF
          FROM PARAMGERAL;
        INSERT INTO ARQMAGPISCOFINS
          (NRORDREGARQMAG, DSREGARQMAG, NRSEQARQMAG)
        VALUES
          (V_CONTADOR, V_DADOS_ECF, P_NRSEQARQMAG);
        V_CONTADOR := NVL(V_CONTADOR,0)+1;
      END LOOP;
    /*Servios Tomados - Notas de Entrada*/
   ELSE
      FOR C_TOMAD IN (SELECT NF.CDFILIAL, NF.NRLANCTONF, NF.NRINSJURNF, NF.CDINSCMUNI, NF.DTEMISSAO, NF.CDSERIEENTR,
                             NF.NRNOTAFISC, IP.VRBASECALCNF, IP.VRIMPOSTONF, IP.VRALIQNF, NF.IDORIGDESTNF,
                             IP.CDIMPOSTO, IM.CDIMPOSTONFE, NF.IDSTATUS, NF.CDFORNECED, NF.CDCLIENTE, NF.CDFILIEMIT
                        FROM NOTAFISCAL NF, LISTA LS, IMPOSTONF IP, IMPOSTO IM
                       WHERE LS.NRLISTA      = P_NRLISTA
                         AND SUBSTR(LS.CDLISTA,1,4) = NF.CDFILIAL
                         AND SUBSTR(LS.CDLISTA,5,10)= NF.NRLANCTONF
                         AND NF.IDENTRSAIDOP = 'E'
                         AND IP.NRLANCTONF   = NF.NRLANCTONF
                         AND IP.CDFILIAL     = NF.CDFILIAL
                         AND IM.CDIMPOSTONFE  IN ('30','35')
                         AND IP.CDIMPOSTO    = IM.CDIMPOSTO
                         AND IP.VRBASECALCNF  > 0
                         ORDER BY NF.CDFILIAL, NF.NRLANCTONF, IM.CDIMPOSTONFE DESC) LOOP
         V_RECIFE := 'N';
         IF (V_NRLANCTONF <> C_TOMAD.CDFILIAL||C_TOMAD.NRLANCTONF)  THEN
            IF C_TOMAD.IDORIGDESTNF = 'C' THEN
               SELECT NVL(C.NRINSJURCLIE,''),
                      NVL(DECODE(M.CDMUNICIBGE,'2611606','S','N'),'N')
                 INTO V_CNPJ_PRESTADOR, V_RECIFE
                 FROM CLIENTE C, ENDECLIE E, MUNICIPIO M
                WHERE C.CDCLIENTE                = C_TOMAD.CDCLIENTE
                  AND E.CDCLIENTE                = C.CDCLIENTE
                  AND NVL(E.IDTPENDECLIE(+),'P') = 'P'
                  AND E.CDPAIS                   = M.CDPAIS
                  AND E.SGESTADO                 = M.SGESTADO
                  AND E.CDMUNICIPIO              = M.CDMUNICIPIO;
            END IF;
            IF C_TOMAD.IDORIGDESTNF = 'F' THEN
               SELECT NVL(NRINSJURFORN,'')
                 INTO V_CNPJ_PRESTADOR
                 FROM FORNECEDOR
                WHERE CDFORNECED = C_TOMAD.CDFORNECED;
               SELECT DECODE(M.CDMUNICIBGE,'2611606','S','N')
                 INTO V_RECIFE
                 FROM ENDEFORN E, MUNICIPIO M
                WHERE E.CDFORNECED            = C_TOMAD.CDFORNECED
                  AND NVL(E.IDTPENDEFORN,'P') = 'P'
                  AND E.CDPAIS                = M.CDPAIS
                  AND E.SGESTADO              = M.SGESTADO
                  AND E.CDMUNICIPIO           = M.CDMUNICIPIO;
            END IF;
            IF C_TOMAD.IDORIGDESTNF = 'L' THEN
               SELECT NVL(NRINSJURFILI,'')
                 INTO V_CNPJ_PRESTADOR
                 FROM FILIAL
                WHERE CDFILIAL = C_TOMAD.CDFILIEMIT;
               SELECT DECODE(M.CDMUNICIBGE,'2611606','S','N')
                 INTO V_RECIFE
                 FROM ENDEFILI E, MUNICIPIO M
                WHERE E.CDFILIAL              = C_TOMAD.CDFILIEMIT
                  AND NVL(E.IDTPENDEFILI,'P') = 'P'
                  AND E.CDPAIS                = M.CDPAIS
                  AND E.SGESTADO              = M.SGESTADO
                  AND E.CDMUNICIPIO           = M.CDMUNICIPIO;
            END IF;
            V_DTBAIXAPAG := NULL;
            V_DATAVAZIA  := 'N';
            IF C_TOMAD.CDIMPOSTONFE = '35' THEN
               BEGIN
                  SELECT TO_CHAR(DTBAIXAPAG,'DD/MM/YYYY')
                    INTO V_DTBAIXAPAG
                    FROM CONTAPAGAR C, BOLETPAGAR B, BAIXAPAGA BX
                   WHERE C.CDFILIAL     = C_TOMAD.CDFILIAL
                     AND C.NRLANCTONF   = C_TOMAD.NRLANCTONF
                     AND C.CDFILIBPAG   = B.CDFILIAL
                     AND C.NRLANBOLPAG  = B.NRLANBOLPAG
                     AND B.CDFILIBAIPAG = BX.CDFILIAL
                     AND B.NRBAIXAPAG   = BX.NRBAIXAPAG
                     AND BX.CDEMPRESA   = P_CDEMPRESA;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                       V_DTBAIXAPAG := NULL;
                       V_DATAVAZIA  := 'S';
               END;
            END IF;
            SELECT '0002'||
                   RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(V_NRINSJUREMPR,'.',''),',',''),'-',''),'/',''),'0'),14,'0')||
                   LPAD(SUBSTR(C_TOMAD.CDINSCMUNI,1,8),8,0) ||       /*Inscrio Mercantil do Prestador*/
                   TO_CHAR(C_TOMAD.DTEMISSAO,'DD/MM/YYYY')  ||       /*Data de Emissao*/
                   RPAD(NVL(SUBSTR(C_TOMAD.CDSERIEENTR,1,1),''),3,' ')|| /*Srie*/
                   '0000'|| /*Sub-Srie*/
                   LPAD(NVL(SUBSTR(C_TOMAD.NRNOTAFISC,LENGTH(C_TOMAD.NRNOTAFISC)-7,8),0),8,0)|| /*Nmero da Nota Final*/
                   REPLACE(LTRIM(TO_CHAR(ROUND(C_TOMAD.VRBASECALCNF,2), '000000000000.00')), '.', ',')|| /*Valor do servio*/
                   'N'|| /*Tipo de documento*/
                   DECODE(C_TOMAD.CDIMPOSTONFE,'35','S','N')|| /*Iss Retido*/
                   DECODE(C_TOMAD.CDIMPOSTONFE,'35',REPLACE(LTRIM(TO_CHAR(ROUND(C_TOMAD.VRIMPOSTONF,2), '000000000000.00')), '.', ','),'000000000000,00')|| /*Valor Iss Retido*/
                   RPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(V_CNPJ_PRESTADOR,'.',''),',',''),'-',''),'/',''),'0'),14,'0')||
                   DECODE(C_TOMAD.CDIMPOSTONFE,'35',DECODE(V_DATAVAZIA,'S',LPAD(' ',10),V_DTBAIXAPAG),LPAD(' ',10))|| /*DATA DO PAGAMENTO*/
                   V_RECIFE
              INTO V_DADOS_TOMAD
              FROM PARAMGERAL;
            INSERT INTO ARQMAGNETICO
              (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
              (V_CONTADOR, V_DADOS_TOMAD, P_NRSEQARQMAG);
            V_CONTADOR := NVL(V_CONTADOR,0)+1;
            UPDATE NOTAFISCAL
               SET IDEXPNFEISS = 'S'
             WHERE CDFILIAL       = C_TOMAD.CDFILIAL
               AND NRLANCTONF     = C_TOMAD.NRLANCTONF;
            V_NRLANCTONF := C_TOMAD.CDFILIAL||C_TOMAD.NRLANCTONF;
         END IF;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_ISS_RECIFE','5.67.xxx'); END;
/

